<?php
	require_once('../../../phplibs/castiron.inc.php');
	require_once(CI_PATH_LIBS.'/session.inc.php');
	require_once(CI_PATH_LIBS.'/system.inc.php');
	require_once(CI_PATH_LIBS.'/loadbar.inc.php');
	require_once(CI_PATH_LIBS.'/tables.inc.php');
	require_once(CI_PATH_LIBS.'/buttons.inc.php');
	require_once(CI_PATH_LIBS.'/core.inc.php');
	
	function tail($file, $lines)
	{
		$handle = fopen($file, "r");
		$linecounter = $lines;
		$pos = -2;
		$beginning = false;
		$text = array();

		while ($linecounter > 0)
		{
			$t = " ";
			while ($t != "\n")
			{
				if(fseek($handle, $pos, SEEK_END) == -1)
				{
					$beginning = true;
					break;
				}
				
				$t = fgetc($handle);
				$pos --;
			}
			$linecounter --;

			if ($beginning) rewind($handle);
			
			$text[$lines-$linecounter-1] = fgets($handle);
			if ($beginning) break;
		}
		
		fclose ($handle);
		
		return $text;
	}


	$table=new CI_TABLES();
	$table->set_headers(array(
		'icon'			=> '&nbsp;',
		'date_time'		=> ci_lbl('system.syslog.date_time'),
		'level'			=> ci_lbl('system.syslog.level'),
		'facility'		=> ci_lbl('system.syslog.facility'),
		'message'		=> ci_lbl('system.syslog.message')
	));

	$messages=array();

	$log_file=$CI_CORE_CONFIG['path']['log'].'/full.log';

	$lines=tail($log_file, 30);
	foreach ($lines as $line)
	{
		list($date, $time, $level, $facility, $message)=preg_split('/\s+/', $line, 5);

		$icon='';

		if ($level == 'warn')
			$icon='<img src="icons/leds/yellow.png" alt="" />';
		elseif (($level != 'trace') && ($level != 'info') && ($level != 'debug'))
			$icon='<img src="icons/leds/red.png" alt="" />';
		else
			$icon='<img src="icons/leds/grey.png" alt="" />';

		$table->add_line(array(
			'icon'		=> $icon,
			'date_time'	=> "$date $time",
			'level'		=> $level,
			'facility'	=> $facility,
			'message'	=> $message
		), array(
			'enabled'	=> 'true'
		));
	}

	$buttons=new CI_BUTTONS();
	$buttons->add_stock_button('download');
?>
<script type="text/javascript">
	function on_button_event(id, task)
	{
		self.location.href='system/syslog/download.php';
	}

	ci_set_reload_page(10000);
</script>

<div class="title"><?php echo ci_lbl("system.syslog.title") ?></div>
<div class="help"><?php echo ci_hlp("system.syslog") ?></div>

<?php echo $buttons->get(); ?>
<div style="clear:both" /><br />
<?php echo $table->get(); ?>


