#!/bin/bash

cd `dirname $0`
MYDIR=`pwd`
MYSCRIPT=`basename $0`
cd ../../..
S2P_PATH_BASE=`pwd`
cd $MYDIR

TWISTER_PATH_BASE=$S2P_PATH_BASE/apps/twister

S2P_OS_GROUPNAME=`$S2P_PATH_BASE/core/libexec/config_view.py system simple | grep ^os.groupname | cut -d= -f2`

# Permissions set
chown -R root.$S2P_OS_GROUPNAME $TWISTER_PATH_BASE/pylibs
chmod 0750 $TWISTER_PATH_BASE/pylibs
chmod 0640 $TWISTER_PATH_BASE/pylibs/*

chown -R root.$S2P_OS_GROUPNAME $TWISTER_PATH_BASE/libexec
chmod -R 0750 $TWISTER_PATH_BASE/libexec

chown -R root.$S2P_OS_GROUPNAME $TWISTER_PATH_BASE/bin
chmod -R 0750 $TWISTER_PATH_BASE/bin

chown -R root.$S2P_OS_GROUPNAME $TWISTER_PATH_BASE/config
chmod -R 0770 $TWISTER_PATH_BASE/config
chmod 0660 $TWISTER_PATH_BASE/config/*.xml
chmod 0660 $TWISTER_PATH_BASE/config/*/*.xml
