#!/usr/bin/env python

# Copyright and license: Please refer to LICENSE.TXT

import sys
import os
import os.path

_selfpath=(os.path.dirname(os.path.realpath(__file__)).split('/'))[:-1]
_selfpath.append('pylibs')
_libspath='/'.join(_selfpath)
sys.path.append(_libspath)

from s2p import *

sys.path.append(CORE_PATH_SDK+'/python')

from s2p_base import *

S2P_CONF_SYSTEM		= xml_to_array(CORE_PATH_CONFIG+'/system.xml')
S2P_CONF_DRIVERS	= xml_to_array(CORE_PATH_CONFIG+'/drivers.xml', 0)

for d in S2P_CONF_DRIVERS['item'].values():
	if d['+']['enabled'][0]['#'] != 'true': continue
	os.system(CORE_PATH_LIBEXEC+'/config_drivers/'+d['+']['name'][0]['#']+'.py')
